<?php

namespace Vialibri\HarvestPlugin;

use Vialibri\HarvestFormatting\DataValidator;

class DataFetcher {

  public function ids() {
    $ids = apply_filters('vialibri_harvest_id_list', array());

    $validator = new DataValidator();
    $ids = $validator->validatedIds($ids);

    sort($ids);
    return $ids;
  }

  public function books($pageNumber, $pageSize) {
    $books = array();

    $validator = new DataValidator();
    $ids = $this->ids();

    $page = $this->getBookPage($pageNumber, $pageSize);

    return $validator->validatedBookData($ids, $page);
  }

  public function sources($pluginVersion) {
    return apply_filters('vialibri_harvest_sources', array(
      array(
        'name' => 'PHP',
        'version' => phpversion()
      ),
      array(
        'name' => 'WordPress',
        'version' => get_bloginfo('version')
      ),
      array(
        'name' => 'viaLibri Harvest Plugin',
        'version' => $pluginVersion
      )
    ));
  }

  public function lastUpdateDate() {
    $books = $this->getBookPage(1, 1);
    return count($books) > 0 ? $books[0]['date_update'] : date('Y-m-d H:i:s');
  }

  private function getBookPage($pageNumber, $pageSize) {
    return apply_filters('vialibri_harvest_book_data', array(), $pageNumber, $pageSize);
  }

}
