<?php
/**
 * Plugin Name: viaLibri Harvest
 * Plugin URI: https://www.vialibri.net/
 * Description: Easily integrate with viaLibri's Harvest API.
 * Version: 0.5.0
 * Author: viaLibri
 * Author URI: https://www.vialibri.net/
 * License: All rights reserved
 */
defined('ABSPATH') or die("No script kiddies please!");

$vharvest_plugin_version = '0.5.0';

///////////////////////////////////

require __DIR__.'/vendor/autoload.php';

Puc_v4_Factory::buildUpdateChecker(
  'https://api.vialibri.net/1/plugins/vialibri-harvest',
  __FILE__,
  'vialibri-harvest'
);

// ---- http://www.example.com/wp-admin/admin-ajax.php?action=vialibri_harvest_id_list ----
add_action( 'wp_ajax_vialibri_harvest_id_list', array('Vialibri\HarvestPlugin\RequestHandler', 'ids') );
add_action( 'wp_ajax_nopriv_vialibri_harvest_id_list', array('Vialibri\HarvestPlugin\RequestHandler', 'ids') );

// ---- http://www.example.com/wp-admin/admin-ajax.php?action=vialibri_harvest_book_data ----
add_action( 'wp_ajax_vialibri_harvest_book_data', array('Vialibri\HarvestPlugin\RequestHandler', 'bookData') );
add_action( 'wp_ajax_nopriv_vialibri_harvest_book_data', array('Vialibri\HarvestPlugin\RequestHandler', 'bookData') );

// And the JSON endpoints used on the admin page.
add_action( 'wp_ajax_vialibri_harvest_id_list_as_json', array('Vialibri\HarvestPlugin\RequestHandler', 'idsAsJson') );
add_action( 'wp_ajax_vialibri_harvest_book_data_as_json', array('Vialibri\HarvestPlugin\RequestHandler', 'bookDataAsJson') );

add_action( 'admin_menu', array('Vialibri\HarvestPlugin\SettingsPage', 'init') );
add_action( 'admin_enqueue_scripts', array('Vialibri\HarvestPlugin\SettingsPage', 'enqueueScript') );
add_action( 'vialibri_harvest_settings_tab_books', array('Vialibri\HarvestPlugin\SettingsPage', 'renderBooksTab') );
